@import '../../../old-styles/index.scss';
@import '../../../styles/utilities/utility';
@import '../../../styles/base/variables';
@import '../../../styles/utilities/mixins';
@import '../../../styles/utilities/extends';

/**
 * Different states
 */
%group-items {
  .ui-dropdown-item-group {
    font: 700 16px/24px Lato;
    color: #59686d;
    background: #f2f1f1;

    &:hover {
      background: #f2f1f1;
    }
  }
}

%item-with-icon {
  .item {
    display: flex;
    align-items: center;
    width: 240px;

    .image {
      width: 15px;
      height: 15px;
      margin-right: 8px;
    }

    .text {
      word-break: break-all;
      display: inline-table;
    }

    .remove-icon {
      display: inline-block;
      position: absolute;
      right: 10px;
      cursor: pointer;
      font-size: 12px;
    }
  }
}

%grouped-state {
  &.grouped {
    .dropdown-wrapper {
      ::ng-deep .custom-dropdown {
        .ui-dropdown-panel {
          .ui-dropdown-items-wrapper {
            max-height: 475px !important;

            .ui-dropdown-items {
              max-height: 475px;
            }
          }
        }
      }
    }
  }
}

/**
 * Dropdown component
 */
.dropdown-component {
  @extend %grouped-state;

  .label {
    @extend %label;

    .secondary-label {
      @extend %secondary-label;
    }
  }

  .dropdown-wrapper {
    position: relative;
    display: flex;
    align-items: center;

    ::ng-deep p-dropdown {
      width: 100%;
    }

    ::ng-deep .custom-dropdown {
      position: relative;
      width: 100%;
      border: none;

      &:focus {
        outline: none;
      }

      &.ui-dropdown-open {
        .ui-dropdown-label-container {
          border: 1px solid map-get($theme, primary);
          outline: none;
          box-shadow: 0 0 0 2px #b2e0f3;
        }
      }

      &.ui-state-focus {
        box-shadow: none;
      }

      &.ui-state-disabled {
        pointer-events: none;
        opacity: 0.8;
      }

      .ui-dropdown-label-container {
        font-family: map-get($font-families, primary);
        font-size: 16px;
        font-weight: map-get($typography-weights, regular);
        position: relative;
        display: flex;
        align-items: center;
        box-sizing: border-box;
        width: 100%;
        height: 40px;
        padding-right: 20px;
        padding-left: 14px;
        cursor: pointer;
        color: rgba(33, 37, 41, 0.7);
        border: 1px solid map-get($theme, third);
        border-radius: 4px;
        background: transparent;

        .ui-dropdown-label {
          font-size: 16px;
          padding-left: 0;
          background: transparent;
          overflow: hidden;
          text-overflow: ellipsis;
          padding-right: 1rem;
        }

        .ui-dropdown-clear-icon {
          right: 26px;
          margin-top: 0;
          font-size: 12px;
          transform: translateY(-50%);
          display: flex;
          height: 20px;
          width: 20px;
          justify-content: flex-end;
          align-items: center;
        }

        .ui-placeholder {
          font-family: map-get($font-families, primary);
          font-size: 16px;
          font-weight: map-get($typography-weights, regular);
          padding-left: 0;
          color: #59686d;
          background: transparent;
        }
      }

      .ui-dropdown-trigger {
        background-color: transparent;
      }

      .ui-dropdown-panel {
        overflow: hidden;
        border: 1px solid map-get($border-colors, highlight);

        .ui-dropdown-items-wrapper {
          max-height: 340px !important;

          .ui-dropdown-items {
            @extend %group-items;
            width: 100%;
            max-height: 340px;
            list-style: none;
            background: #ffffff;

            .ui-dropdown-item {
              @extend %item-with-icon;
              font-family: map-get($font-families, primary);
              font-size: 16px;
              font-weight: map-get($typography-weights, regular);
              padding: 10px 15px;
              cursor: pointer;
              color: rgba(33, 37, 41, 1);
              border-bottom: 1px solid #e3e4e4;
              position: relative;

              &:hover {
                background: #f4f5f7;
              }

              &.ui-state-highlight {
                font-weight: map-get($typography-weights, medium);
                position: relative;
                background: #EDF9FD;
              }
            }
          }
        }
      }
    }

    .custom-clear {
      display: inline-block;
      position: absolute;
      right: 26px;
      cursor: pointer;
      font-size: 12px;
    }
  }

  .helper-text {
    font: 400 16px/20px Lato;
    margin-top: 6px;
    margin-left: 14px;
  }
}
